Subject: Re: [bug?] tg3: Failed to load firmware "tigon/tg3_tso.bin"

From: Jeff Garzik <[email-masked]>
Date: Sat, 05 Jul 2008 02:05:56 -0400

David Miller wrote:
> External firmware is by design an error prone system, even with
> versioning.  But by being built and linked into the driver, it
> is fool proof.
> 
> On a technical basis alone, we would never disconnect a crucial
> component such as firmware, from the driver.  The only thing
> charging these transoformations, from day one, is legal concerns.
> 
> I've been against request_firmware() from the beginning, because
> they make life unnecessarily difficult, and it is error prone no
> matter how well you design the validation step.

Precisely.  External firmware is quite simply less error prone, since it 
is always with the driver code that uses it.  No other system can 
approach that reliability.

But I did (and do) think request_firmware() is a necessary piece of the 
puzzle.  Personally I've always felt it is a design choice by the 
individual driver author, whether to compile-in firmware or use external 
firmware.

	Jeff